<?php 
 
define('URL_LOGIN', 'https://ibank.klikbca.com/authentication.do');
define('URL_SALDO', 'https://ibank.klikbca.com/balanceinquiry.do');
define('URL_MUTASI_INDEX', 'https://ibank.klikbca.com/accountstmt.do?value(actions)=acct_stmt');
define('URL_MUTASI_VIEW', 'https://ibank.klikbca.com/accountstmt.do?value(actions)=acctstmtview');
define('URL_MUTASI_DOWNLOAD', 'https://ibank.klikbca.com/stmtdownload.do?value(actions)=account_statement');
 
if(!is_dir(SAVEHTML)) {
    mkdir(SAVEHTML,0777,1);
}

class klikbca { 
    var $ch         = false; 
    var $ip         = ''; 
    var $last_html  = '';
    var $logged_in  = false;
    var $password   = 'password_saya';
    var $username   = 'username_saya';
    var $online     = true;
    var $error      = '';
 
    function klikbcaon() { 
        $this->ip = $_SERVER['REMOTE_ADDR'];
        $this->logged_in = false;
    }
 
    function cek_saldo() { 
        if ($this->logged_in == false) {
            //trigger_error('LOGIN FIRST', E_USER_WARNING);
            //return false;
        } 
                
        if($this->online == true) {
            $res = $this->my_curl_get(URL_SALDO);
            $this->last_html = $res['response'];
            if(is_dir(SAVEHTML)) {
                $file_log	 = SAVEHTML."saldo.html";
                $myfile = fopen($file_log, "w") or die("Unable to open file $file_log !");
                fwrite($myfile, $res['response']);
                fclose($myfile);
            }
        } elseif(is_file(SAVEHTML."saldo.html")) {
            $txt_file  = file_get_contents(SAVEHTML."saldo.html");
            $this->last_html = $txt_file;
        } else {
            $this->last_html = "<div class='alert alert-warning'>File tidak ditemukan</div>";
        }
        
        return true;
    }

    function to_value($value_format) { 
        $result = $value_format;
        $result = str_replace(".00","",$result);
        $result = str_replace(",","",$result);
        return $result;
    }

    function save($file,$data) {
        if(!is_dir(SAVETO)) {
            mkdir(SAVETO,0777,1);
        }
        $file_log	 = SAVETO.$file.".json";
		$myfile = fopen($file_log, "w") or die("Unable to open file $file_log !");
		fwrite($myfile, $data);
		fclose($myfile);

    }
	
	function cek_mutasi($filter=array()) { 
        if ($this->logged_in == false) {
            $this->error      = 'Login Dulu Bos';
        } 

        // cek mutasi bulanan
        $typemutasi = 2; // bulanan
        $periode    = 1; // 1 bulan sebelumnya (max 2)

		$data = array(
            'value(r1)' => $typemutasi,
            'value(x)' => $periode,
            'value(submit1)' => 'Lihat Mutasi Rekening',
            );
        
        // cek mutasi harian
        $typemutasi = 1; // bulanan
        $tanggal_start  = date("Y-m-d");
        $tanggal_end    = date("Y-m-d");

        if(isset($filter['start']) && $filter['start']) {
            $tanggal_start  = $filter['start'];
        }

        if(isset($filter['end']) && $filter['end']) {
            $tanggal_end  = $filter['end'];
        }
        $start = explode("-",$tanggal_start);
        $end = explode("-",$tanggal_end);
        
        $data = array(
            'value(r1)' => $typemutasi,
            'value(startDt)' => $start[2],
            'value(startMt)' => $start[1],
            'value(startYr)' => $start[0],
            'value(endDt)' =>  $end[2],
            'value(endMt)' => $end[1],
            'value(endYr)' => $end[0],
            'value(submit1)' => 'Lihat Mutasi Rekening',
            );
        
        
        if($this->online == true) {
            $res = $this->my_curl_post(URL_MUTASI_VIEW,$data);
            $this->last_html = $res['response'];

            $file_log	 = SAVEHTML."mutasi.html";
            $myfile = fopen($file_log, "w") or die("Unable to open file $file_log !");
            fwrite($myfile, $res['response']);
            fclose($myfile);

        } elseif(is_file(SAVEHTML."mutasi.html")) {
            $txt_file  = file_get_contents(SAVEHTML."mutasi.html");
            $this->last_html = $txt_file;
        } else {
            $this->last_html = "<div class='alert alert-warning'>File tidak ditemukan</div>";
        }
        
        return true;
    }
  
    function login() {
        $this->logged_in = false;
        if($this->online == true) {
            $data = array(
                'value(actions)' => 'login',
                'value(user_id)' => $this->username,
                'value(user_ip)' => $this->ip,
                'value(pswd)' => $this->password,
                'value(Submit)' => 'LOGIN'
                );

            $data = http_build_query($data);
            $res = $this->my_curl_post(URL_LOGIN, $data);
            $this->last_html = $res['response'];
            if (preg_match('/value\(user_id\)/i', $res['response'])) {
                $this->error      = 'Login Gagal Bos';
                return false;
            } 
        }
        $this->logged_in = true;
        return true;
    }

    function logout() {
        if($this->online == true) {
            $data = array(
                'value(actions)' => 'logout',
                );

            $data = http_build_query($data);
            $res = $this->my_curl_post(URL_LOGIN, $data);
        }
        $this->logged_in = false;
        return true;
    }
 
    function my_curl_close() {
        if ($this->ch != false) {
            curl_close($this->ch);
        }
    }
 
    function my_curl_get($url, $ref = '') {
        if ($this->ch == false) {
            $this->my_curl_open();
        }
 
        $ssl = false;
        if (preg_match('/^https/i', $url)) {
            $ssl = true;
        }
 
        if ($ssl) {
            curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, false);
        }
 
        if ($ref == '') {
            $ref = $url;
        }
 
        curl_setopt($this->ch, CURLOPT_URL, $url);
        curl_setopt($this->ch, CURLOPT_REFERER, $ref);
        $res = curl_exec($this->ch);
        $info = curl_getinfo($this->ch);
        return array(
            'response' => trim($res),
            'info' => $info
            );
    }
 
 
 
    function my_curl_open() {
        $this->ch = curl_init();
        curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($this->ch, CURLOPT_AUTOREFERER, true);
        @curl_setopt($this->ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($this->ch, CURLOPT_MAXREDIRS, 2);
        curl_setopt($this->ch, CURLOPT_COOKIEFILE, dirname(__FILE__).'/curl-cookie.txt');
        curl_setopt($this->ch, CURLOPT_COOKIEJAR, dirname(__FILE__).'/curl-cookie.txt');
        curl_setopt($this->ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
 
    }
 
 
 
    function my_curl_post($url, $post_data, $ref = '') {
        if ($this->ch == false) {
            $this->my_curl_open();
        }
        $ssl = false;
        if (preg_match('/^https/i', $url)) {
            $ssl = true;
        }
        if ($ssl) {
            curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, false); 
        }
        if ($ref == '') {
            $ref = $url;
        } 
        curl_setopt($this->ch, CURLOPT_URL, $url);
        curl_setopt($this->ch, CURLOPT_REFERER, $ref);
        curl_setopt($this->ch, CURLOPT_POST, 1);
        curl_setopt($this->ch, CURLOPT_POSTFIELDS, $post_data);
        $res = curl_exec($this->ch);
        $info = curl_getinfo($this->ch);
        return array(
            'response' => trim($res),
            'info' => $info
            );
 
    }
 
} ?>