<?php
// Parsing HTML PHP https://www.coralnodes.com/parsing-html-in-php/#h3_7
require_once('config.php');
require_once('bca.php');
$klikbca = new klikbca(); 
if(isset($_POST['password']) && $_POST['password'] && 
    isset($_POST['username']) && $_POST['username']) {
    $klikbca->password = $_POST['password'];
    $klikbca->username = $_POST['username'];
} elseif(USERNAME != "" && PASSWORD != "") {
    $klikbca->username = USERNAME;
    $klikbca->password = PASSWORD;
} else {
    header('Content-Type: application/json');
    $output = array("curl_res"  => "",
                    "dataset"   => "Username/Password tidak boleh kosong",
                    "action"    => '',
                    "raw"       => false,
                    "preview"   => false,
                    );
    echo json_encode($output);
    exit;
}

$res = $klikbca->login();
if ($res == false) {
    
    header('Content-Type: application/json');
    $output = array("curl_res"  => "",
                    "dataset"   => $klikbca->error,
                    "action"    => '',
                    "raw"       => false,
                    "preview"   => false,
                    );
    echo json_encode($output);
    exit;
}

libxml_use_internal_errors(true);

if(isset($_POST['start']) && $_POST['start']) {
    $start = $_POST['start'];
} else {
    $start = date("Y-m-d");
}

if(isset($_POST['end']) && $_POST['end']) {
    $end = $_POST['end'];
} else {
    $end = date("Y-m-d");
}

if(isset($_POST['output']) && $_POST['output']) {
    $outputtype = $_POST['output'];
} else {
    $outputtype = "api";
}
 
$filtermutasi = array("start"   => $start,
                     "end"      => $end);



$res = $klikbca->cek_mutasi($filtermutasi);
if ($res == true) {

    $data_grab = $klikbca->last_html;
    // di parse htmlnya
    $dom = new DOMDocument();
    $dom->loadHTML($data_grab);
    $h2s = $dom->getElementsByTagName('table'); //DOMElement
    $xpath = new DOMXpath($dom);
    // delete foto
    $elems = $xpath->query("//img");
    foreach($elems as $elem ) {
        $elem->parentNode->removeChild($elem);
    }
    // delete script
    $elems = $xpath->query("//script");
    foreach($elems as $elem ) {
        $elem->parentNode->removeChild($elem);
    }
    if(isset($h2s[4]->nodeValue)) {
        $data = $h2s[4]->nodeValue;
    } else {
        $data = "Element DOM tidak ditemukan";
    }
    // area modifikasi
    $data = str_replace("\n\n","<hr>",$data);
    $data = str_replace("\n","",$data);
	$data = str_replace("<hr><hr>","<br>",$data);
    $data = str_replace("<hr>",";",$data);
    $array = explode("<br>",$data);
    // end area modifikasi
    $dataset = array();
    $saldo = array();
    $rows  = 0;
    $filecontrol = date("Ymd").".".$start.".".$end.".".$klikbca->username;
    $datereport  = date("Y-m-d H:i:s");
    if($array) {
        foreach($array as $row) {
            if($row) {
            $info = explode(";",$row);
                if(isset($info[4]) && trim($info[4]) != 'Saldo') {
                    $rows++;
                    $dataset[$filecontrol][$rows] = array(  "id"              => $rows,
                                                            "tgl_setlement"   => isset($info[0]) ? trim($info[0]) : false,
                                                            "keterangan"      => isset($info[1]) ? trim(preg_replace('/\s+/', ' ',$info[1])) : false,
                                                            "cabang"          => isset($info[2]) ? trim($info[2]) : false,
                                                            "nilai"           => isset($info[3]) ? trim($info[3]) : false,
                                                            "value"           => isset($info[3]) ? $klikbca->to_value($info[3]) : false,
                                                            "kategori"        => isset($info[4]) ? trim($info[4]) : false,
                                                            "saldo_akhir"     => isset($info[5]) ? trim($info[5]) : false,
                                                            "tgl_cek"         => $datereport,
                                                            );
                    $saldo = array("nilai"  => isset($info[5]) ? trim($info[5]) : false,
                                   "value"  => isset($info[5]) ? $klikbca->to_value($info[5]) : false);
                }
            }
        }
    }

    // row data baru
    $dataset['rows'] = $rows;
    $dataset['saldo'] = $saldo;
    $rowdatalama            = 0;
    if(is_file(SAVETO.$filecontrol.".json")) {
        // formatfile [tanggal-type-jumlahrow-];
        $txt_file               = file_get_contents(SAVETO.$filecontrol.".json");
        $dbData                 = json_decode($txt_file,1);
        $rowdatalama            = $dbData['rows'];
    }

    // cek terakhir berapa?
    // klo row saat ini lebih banyak dari row di file 
    // bearti ada data baru
    if(is_file(SAVETO.$filecontrol.".json")) {
        $action = 'Data Sudah disimpan <a href="'.SAVETO.$filecontrol.".json".'" target="_blank">Disini</a>';
    } else {
        $klikbca->save($filecontrol,json_encode($dataset));
        $action = 'Ada data baru <a href="'.SAVETO.$filecontrol.".json".'" target="_blank">Disini</a>';
    }
    if(isset($rowdatalama) && $rowdatalama < $rows) {
        // aktifitas data baru
        $klikbca->save($filecontrol,json_encode($dataset));
        $action = 'Ada data baru <a href="'.SAVETO.$filecontrol.".json".'" target="_blank">Disini</a>';
    }

    $table = "<table class='table table-striped'>
                <tr>
                    <td>Tanggal</td>
                    <td>Keterangan</td>
                    <td>Cabang</td>
                    <td>Nilai</td>
                    <td>Kategori</td>
                    <td>Saldo Akhir</td>
                </tr>";
    if(isset($dataset[$filecontrol]) && $dataset[$filecontrol]) {
        foreach($dataset[$filecontrol] as $tr) {
            $table .= "<tr>
                        <td>".$tr['tgl_setlement']."</td>
                        <td>".$tr['keterangan']."</td>
                        <td>".$tr['cabang']."</td>
                        <td>".$tr['nilai']."</td>
                        <td>".$tr['kategori']."</td>
                        <td>".$tr['saldo_akhir']."</td>
                    </tr>";
        }
    } else {
        $table .= "<tr>
                        <td colspan='6'>Tidak Ada Data Transaksi</td>
                    </tr>";
    }
    $table .= "</table>";

    $outputpreview = $dom->saveHTML();
    if($outputtype == "table") {
        $outputpreview = $table;
    }

    header('Content-Type: application/json');
    $output = array("curl_res"  => $res,
                    "dataset"   => $dataset,
                    "action"    => $action,
                    "raw"       => $data,
                    "preview"   => $outputpreview,
                    );
    echo json_encode($output);
} else {

    header('Content-Type: application/json');
    $output = array("curl_res"  => $res,
                    "dataset"   => array($klikbca->error),
                    "action"    => '',
                    "raw"       => $klikbca->error,
                    "preview"   => $dom->saveHTML(),
                    );
    echo json_encode($output);
}
// logout
$klikbca->logout();
