<?php
// Parsing HTML PHP https://www.coralnodes.com/parsing-html-in-php/#h3_7
require_once('config.php');
require_once('bca.php');
$klikbca = new klikbca();

if(isset($_POST['password']) && $_POST['password'] && 
    isset($_POST['username']) && $_POST['username']) {
    $klikbca->password = $_POST['password'];
    $klikbca->username = $_POST['username'];
} elseif(USERNAME != "" && PASSWORD != "") {
    $klikbca->username = USERNAME;
    $klikbca->password = PASSWORD;
} else {
    header('Content-Type: application/json');
    $output = array("curl_res"  => "",
                    "dataset"   => "Username/Password tidak boleh kosong",
                    "action"    => '',
                    "raw"       => false,
                    "preview"   => false,
                    );
    echo json_encode($output);
    exit;
}


if(isset($_POST['output']) && $_POST['output']) {
    $outputtype = $_POST['output'];
} else {
    $outputtype = "api";
}

$res = $klikbca->login();
if ($res == false) {
    echo $klikbca->last_html;
    exit;
}
libxml_use_internal_errors(true);
$res = $klikbca->cek_saldo();
if ($res != false) {
    $data_grab = $klikbca->last_html;
    // di parse htmlnya
    $dom = new DOMDocument();
    /*
        Pakai Dom load bila
        $dom->load('path/to/save');
    */
    $dom->loadHTML($data_grab);
    $table = $dom->getElementsByTagName('table'); //DOMElement
    $xpath = new DOMXpath($dom);
    // delete foto
    $elems = $xpath->query("//img");
    foreach($elems as $elem ) {
        $elem->parentNode->removeChild($elem);
    }
    // delete script
    $elems = $xpath->query("//script");
    foreach($elems as $elem ) {
        $elem->parentNode->removeChild($elem);
    }
        // delete style
        $elems = $xpath->query("//link");
        foreach($elems as $elem ) {
            $elem->parentNode->removeChild($elem);
        }
    
    $data = str_replace("\n\n","<hr>",$table[2]->nodeValue);
    $data = str_replace("\n","<hr>",$data);
    $data = str_replace("  ","",$data);
    $data = str_replace(" <hr>","<hr>",$data);
    $data = str_replace("<hr> ","<hr>",$data);
    $data = str_replace("<hr> <hr>","<hr><hr>",$data);
    $data = str_replace(" <hr> ","<hr>",$data);
    $data = str_replace(" <hr>","<hr>",$data);
    $data = str_replace("<hr> ","<hr>",$data);
    $data = str_replace("<hr> ","<hr>",$data);
    $data = str_replace("<hr><hr><hr><hr><hr><hr><hr><hr><hr>","===",$data);
    $data = str_replace("<hr><hr><hr><hr><hr><hr><hr>","-",$data);
    $data = str_replace("<hr><hr><hr><hr><hr><hr>","-",$data);
    $data = str_replace("&nbsp;","",$data);
    $data = str_replace("<hr>","",$data);
    $array = explode("===",$data);

    // end area modifikasi
    $dataset = array();
    $saldo = array();
    $rows  = 0;
    $filecontrol = date("Ymd")."-ceksaldo-".$klikbca->username;
    $datereport  = date("Y-m-d H:i:s");
    // end area modifikasi
    if($array) {
        if(isset($array[1]) && $array[1]) {
            $row = explode("-",$array[1]);
            if(isset($row[0])) {
                $dataset[$filecontrol][] = array("header"=>"No.Rekening",
                                    "value"=>$row[0]);
            }
            if(isset($row[1])) {
                $dataset[$filecontrol][] = array("header"=>"Jenis Rekening",
                                    "value"=>$row[1]);
            }
            if(isset($row[2])) {
                $dataset[$filecontrol][] = array("header"=>"Mata Uang",
                                    "value"=>$row[2]);
            }
            if(isset($row[3])) {
                $dataset[$filecontrol][] = array("header"=>"Saldo Efektif",
                                    "value"=>$row[3]);
                $rows = $row[3];
            }
        }
    }


    if(is_file(SAVETO.$filecontrol.".json")) {
        // formatfile [tanggal-type-jumlahrow-];
        $txt_file               = file_get_contents(SAVETO.$filecontrol.".json");
        $dbData                 = json_decode($txt_file,1);
        $rowdatalama            = $dbData[3]['value'];
    } else {
        $rowdatalama            = 0;
    }


    if(is_file(SAVETO.$filecontrol.".json")) {
        $action = 'Data Sudah disimpan <a href="'.SAVETO.$filecontrol.".json".'" target="_blank">Disini</a>';
    }
    
    if(isset($rowdatalama) && $rowdatalama != $rows) {
        // aktifitas data baru
        $klikbca->save($filecontrol,json_encode($dataset));
        $action = 'Ada data baru <a href="'.SAVETO.$filecontrol.".json".'" target="_blank">Disini</a>';
    } else {
        $action = '-';
    }


    $table = "<table class='table table-striped'>";
    if(isset($dataset[$filecontrol]) && $dataset[$filecontrol]) {
        foreach($dataset[$filecontrol] as $tr) {
            $table .= "<tr>
                        <td>".$tr['header']."</td>
                        <td>".$tr['value']."</td>
                    </tr>";
        }
    } else {
        $table .= "<tr>
                        <td colspan='2'>Tidak Ada Data Transaksi</td>
                    </tr>";
    }
    $table .= "</table>";


    $outputpreview = $dom->saveHTML();
    if($outputtype == "table") {
        $outputpreview = $table;
    }

    header('Content-Type: application/json');
    $output = array("curl_res"  => $res,
                    "dataset"   => $dataset,
                    "action"    => $action,
                    "raw"       => $data,
                    "preview"   => $outputpreview
                    );
    echo json_encode($output);
} else {
    header('Content-Type: application/json');
    $output = array("curl_res"  => $res,
                    "dataset"   => array($klikbca->error),
                    "action"    => '',
                    "raw"       => $klikbca->error,
                    "preview"   => $dom->saveHTML(),$outputtype,
                    );
    echo json_encode($output);
}
// logout
$klikbca->logout();
