<?php require('config.php'); ?>
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
    <title>GrabBCA</title>
  </head>
  <body>
  <nav class="navbar navbar-expand-lg  navbar-dark bg-primary">
  <a class="navbar-brand" href="index.php">GrabBCA</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <a class="nav-link" href="index.php">Home</a>
      </li>
      <li class="nav-item">
        <a class="nav-link grepdata" href="ceksaldo.php">Cek Saldo</a>
      </li>
    </ul>
  </div>
</nav>
<div class="container">
    <div class="row">
        <div class="col-md-3">
            <form>
              <h2 class="text-center">Akun IB-BCA</h2>
              <div class="form-group">
                <label>Username</label>
                <input class="form-control" type="password" id="username">
              </div>
              <div class="form-group">
                <label>Password (angka)</label>
                <input class="form-control" type="password" id="password">
              </div>
              <h2 class="text-center">Cek Mutasi</h2>
              <div class="form-group">
                <label>Dari Tanggal</label>
                <input class="form-control" type="date" id="start">
              </div>
              <div class="form-group">
                <label>Sampai Tanggal</label>
                <input class="form-control" type="date" id="end">
              </div>
              <div class="form-group">
                <label>Type Hasil Grab</label>
                <select class="form-control" id="output">
                  <option value="page">Page Mutasi</option>
                  <option value="table">Table</option>
                </select>
              </div>
                <button class="btn btn-primary grepdata" data-target="cekmutasi.php" type="button">Cek Mutasi</button>
            </form>
            <div class="well" id="actionnote" sytle="display:none;"></div>
        </div>
        <div class="col-md-9">
            <h2>Hasil Grap</h2>
            <div role="tabpanel">
            <ul class="nav nav-tabs" id="myTab" role="tablist">
              <li class="nav-item">
                <a class="nav-link active" id="tabAPI-tab" data-toggle="tab" href="#tabAPI" role="tab" aria-controls="home" aria-selected="true">API</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" id="tabTable-tab" data-toggle="tab" href="#tabTable" role="tab" aria-controls="profile" aria-selected="false">Preview</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" id="tabRaw-tab" data-toggle="tab" href="#tabRaw" role="tab" aria-controls="messages" aria-selected="false">Raw</a>
              </li>
            </ul>
              <div class="tab-content">
                <div class="tab-pane active" id="tabAPI" role="tabpanel" aria-labelledby="tabTable">
                  <h4 class="text-center">Result API</h4>
                  <pre id="result-code">Data Hasil Grab akan muncul disini</pre>
                </div>
                <div class="tab-pane" id="tabTable" role="tabpanel" aria-labelledby="tabTable">
                  <h4 class="text-center">Result Preview</h4>
                  <div id="hasilhtml"></div>
                </div>
                <div class="tab-pane" id="tabRaw" role="tabpanel" aria-labelledby="tabRaw">
                  <h4 class="text-center">Result Raw</h4>
                  <textarea rows="10" class="form-control" id="codeview"></textarea>
                </div>
              </div>
            </div>
        </div>
    </div>
</div>
<script
  src="https://code.jquery.com/jquery-3.5.1.min.js"
  integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0="
  crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script>
<script>
function getJsonAPI(base_url,options={},resultData) {
	var result_url = base_url;
	var request = new XMLHttpRequest()
	request.open('GET', result_url, true);
	request.onreadystatechange = function() {
	  if (this.readyState == 4 && this.status == 200) {
		resultData(JSON.parse(this.responseText),options);
	  }
	};
	request.send();
}
    $(document).ready(function(e) {
        $(".grepdata").click(function(e){
            e.preventDefault();
            $("#result-code").html('Load data....');
            $("#hasilhtml").html('Load data....');
            $("#actionnote").html('Load data....');
            $("#codeview").val('');
            var targetLink = $(this).attr("data-target");
            if($(this).attr("href")) {
              targetLink = $(this).attr("href");
            }
            $.ajax({
                type: 'POST',
                url: targetLink,
                data: {
                  start     : $("#start").val(),
                  end       : $("#end").val(),
                  username  : $("#username").val(),
                  password  : $("#password").val(),
                  output    : $("#output").val(),
                }
            }).done(function(response) {
                // Make sure that the formMessages div has the 'success' class.
                // var result = jQuery.parseJSON(response);
                $("#result-code").html(JSON.stringify(response.dataset,null,2));
                $("#hasilhtml").html(response.preview);
                $("#actionnote").html(response.action);
                $("#codeview").val(response.raw);
            }).fail(function() {
              alert("gagal karena "+targetLink);
            })

        })
    })
</script>
  </body>
</html>
